variables:
  BUCKET_NAME: lambda-codes-bucket-jperezr
  ZIP_FILE_NAME: lambda_k8s_deploy_code.zip
  LAMBDA_FUNCTION_NAME : helloWorld
  PARENT_FOLDER: LambdaIncidentManager
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

stages:
  - package
  - test
  - scanner
  - build
  - upload
  - publish


Install dependencies:
  image: python
  stage: package
  script:
    - python3 -m venv venv
    - source venv/bin/activate
    - pip install -r $PARENT_FOLDER/test/requirements.txt
  artifacts:
    paths: [venv/]

#unit tests:
#  image: python
#  script:
#  stage: test
#    - source venv/bin/activate
#    - python3 -m coverage run -m pytest -rap --junitxml coverage.xml
#    - python3 -m pylint -ry --exit-zero core > pylint_report.txt
#    - python3 -m coverage xml -i

#sonarcloud-check:
#  stage: scanner
#  image:
#    name: sonarsource/sonar-scanner-cli:latest
#    entrypoint: [""]
#  cache:
#    key: "${CI_JOB_NAME}"
#    paths:
#      - .sonar/cache
#  script:
#    - cd $PARENT_FOLDER/
#    - sonar-scanner
#  only:
#    - merge_requests
#    - master
#    - develop

zip file:
  image: alpine
  stage: build
  script:
    - apk add zip
    - rm -rf $PARENT_FOLDER/core/__pycache__
    - rm -rf $PARENT_FOLDER/core/$ZIP_FILE_NAME
    - cd $PARENT_FOLDER/core
    - zip -r $ZIP_FILE_NAME lambda_function.py
  artifacts:
    paths: [$PARENT_FOLDER/core/$ZIP_FILE_NAME]


upload zip s3:
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  stage: upload
  script:
    - cd $PARENT_FOLDER/core
    - aws s3 cp $ZIP_FILE_NAME s3://$BUCKET_NAME/$ZIP_FILE_NAME

update lambda code:
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  stage: publish
  script:
    - cd $PARENT_FOLDER/core
    - aws lambda update-function-code --function-name $LAMBDA_FUNCTION_NAME --s3-bucket $BUCKET_NAME --s3-key $ZIP_FILE_NAME




